function [v,p]=costoa(D,H,l,pre)
err=1
[m,n]=size(H)
v=-%inf*ones(n,1)
id=(1+l)*speye(n,n)
iter=1
while err>pre 
  iter=iter+1
//  disp(iter)
  [h,p,c]=amax(D,H*v)
  w=lusolve(id-p*H,c)
  err=norm(v-w,'inf')
//  disp(err)
  v=w
  end

  
function [v0,q]=costoe(D,H,pre)
[v,p]=costoa(D,H,0.011,pre)
[w,q]=costoa(D,H,0.001,pre)
v0=0.0011*(w-v)


function [v,p]=costo(D,H,l)
if l>0 then
  [v,p]=costoa(D,H,l,0.001)
  v=l*v
else
  [v,p]=costoe(D,H,0.001)
end



function [W,f,err]=wardrop(H,d,a,niter)
pen=0.001
ci=10
C=0.1
err=1
[m,n]=size(H)
V=ones(m,1)
un=ones(n,1)
nd=size(d,2)
D=d*ones(nd,1)
Q=diag(sparse(un*C))
qs=zeros(n,1)
QS=qs 
q=ones(n,nd)*ci
iter=0
printf("  ")
printf("=======================")
printf("Wardrop/Q/%3d/%3d/%4d/",m,n,nd)
printf("=======================")
printf("  ")
printf("------------------")
printf("| iter |  erreur |")
printf("------------------")
while niter>iter 
  iter=iter+1
  DD=nd*D+H*Q*qs
  W=lusolve(H*Q*H'+a*speye(m,m),DD);
  QS=(H'*W-qs)/nd
  QQ=sign(QS)
  Q=diag(sparse(-pen*min(0,QQ)+C*max(0,QQ)))
  qs=spzeros(n,1)
  for i=1:nd
    di=d(:,i)+H*diag(QS)*q(:,i)
    w=lusolve(H*sparse(diag(q(:,i)))*H'+a*speye(m,m),di);
    qqq=H'*w-QS
    qs=qs+qqq
    qq=sign(qqq)
    q(:,i)=sparse(-pen*min(0,qq)+ci*max(0,qq))
  end 
  err=norm(V-W,'inf')
  printf("|  %2d  | %2.1e |",iter,err)
  V=W
end
f=min(0,QS)*pen+C*max(0,QS)

function [W,f,qd,err]=WardropOLD(H,d,r,a,niter)
pen=0.001;
ci=10;
C=diag(sparse(r));
//ci=10*C
err=1;
[m,n]=size(H);
//id=eye(n,n);
un=ones(n,1);
nd=size(d,2);
CC=un'*r/nd;
D=full(d*ones(nd,1));
Q=C;
F=r;
qs=zeros(n,1);
QS=qs; 
q=ci*ones(n,nd);
//q=r*ones(1,nd);
qd=zeros(n,nd); //modif
iter=0;
printf("  ");
printf("=======================");
printf("Wardrop/Q/%3d/%3d/%4d/",m,n,nd);
printf("=======================");
printf("  ");
printf("------------------");
printf("| iter |  erreur |");
printf("------------------");
for j=1:5
  DD=(CC/ci+nd)*D;
  W=lusolve(H*Q*H'+a*speye(m,m),DD);
  QS=H'*W/(nd+CC/ci);
  QQ=sign(QS);
  Q=diag(sparse(-pen*min(0,QQ)+C*max(0,QQ)));
end
V=W;
f=Q*QS;
for i=1:nd
//  pause
  qd(:,i)=f/nd;
end
while niter>iter 
  iter=iter+1;
  qs=spzeros(n,1);
//  f=Q*QS;
  for i=1:nd
    QSi=QS-0*(Q\qd(:,i))
    for k=1:5
    di=d(:,i)+H*diag(QSi)*q(:,i);
//    admit=un./(un./q(:,i)+Q\un);
    admit=q(:,i)
    w=lusolve(H*sparse(diag(admit))*H'+a*speye(m,m),di);
//    qqq=H'*w-QSi;
    qqq=H'*w-QS;
    qq=sign(qqq);
//    pause
    q(:,i)=sparse(-pen*min(0,qq)+ci*C*max(0,qq));
     end
  qd(:,i)=diag(qqq)*admit;
  qs=qs+qqq;
//  qs=qs+diag(q(:,i))\qd(:,i);
  end 
//  pause
  for j=1:5
  DD=nd*D+H*Q*qs;
  W=lusolve(H*Q*H'+a*speye(m,m),DD);
  QS1=(H'*W-qs)/nd;
  f1=Q*QS1
  f2=qd*ones(nd,1)
  f=f1*1.0+0.0*f2
  QQ=sign(f)
  Q=diag(sparse(-pen*min(0,QQ)+C*max(0,QQ)));
  QS=Q\f
  end
//  err=norm(V-W,'inf')
  err=norm(f-F,'inf')
  printf("|  %2d  | %2.1e |",iter,err)
  V=W
  F=f
end
//f=min(0,QS)*pen+C*max(0,QS)

function [W,f,qd,err]=Wardrop(H,d,r,a,niter)
pen=0.0001;
ci=10;
C=diag(sparse(r));
//ci=10*C
err=1;
[m,n]=size(H);
//id=eye(n,n);
un=ones(n,1);
nd=size(d,2);
CC=un'*r/nd;
D=full(d*ones(nd,1));
Q=C;
F=r;
qs=zeros(n,1);
QS=qs; 
q=ci*ones(n,nd);
//q=r*ones(1,nd);
qd=zeros(n,nd); //modif
iter=0;
for j=1:4
//  DD=(CC/ci+nd)*D;
  DD=nd*D;
  W=lusolve(H*Q*H'+a*speye(m,m),DD);
//  QS=H'*W/(nd+CC/ci);
  QS=H'*W/nd;
  QQ=sign(QS);
  f=Q*QS
  Q=diag(sparse(-pen*min(0,QQ)+C*max(0,QQ)));
//  printf("  ");
  printf("ct agrege pen=%2.3e , ct agrege=%2.3e",f'*(Q\f),f'*(C\f));
//  printf("  ");
//  Q=C
end
    Q=C
//V=W;
//f=Q*QS;
printf("  ");
printf("=======================");
printf("Wardrop/Q/%3d/%3d/%4d/",m,n,nd);
printf("=======================");
printf("  ");
printf("-----------------------------");
printf("| iter |   cout    | erreur  |");
printf("-----------------------------");

for i=1:nd
//  pause
  qd(:,i)=f/nd;
end
   QS=C\f;
while niter>iter 
  iter=iter+1;
//  qs=spzeros(n,1);
   cs=0;
//  f=Q*QS;
  for i=1:nd
    QSi=QS-(Q\qd(:,i))
    for k=1:6
    admit=un./(un./q(:,i)+Q\un);
    di=d(:,i)+H*diag(QSi)*admit;
//    admit=q(:,i)
    w=lusolve(H*sparse(diag(admit))*H'+a*speye(m,m),di);
    qqq=H'*w-QSi;
    qq=sign(qqq);
//    pause
    q(:,i)=sparse(-pen*min(0,qq)+ci*max(0,qq));
     end
     qd(:,i)=diag(qqq)*admit;
     QS=QSi+(q(:,i)\qd(:,i));
//  qs=qs+qqq;
    cs=cs+qd(:,i)'*(diag(q(:,i))\qd(:,i));
//  qs=qs+diag(q(:,i))\qd(:,i);
  end 
//  pause
//  for j=1:5
//  DD=nd*D+H*Q*qs;
//  W=lusolve(H*Q*H'+a*speye(m,m),DD);
//  QS1=(H'*W-qs)/nd;
//  f1=Q*QS1
//  f2=qd*ones(nd,1)
    f=qd*ones(nd,1)
//  f=f1*0.0+1.0*f2
//    QQ=sign(f)
//    Q=diag(sparse(-pen*min(0,QQ)+C*max(0,QQ)));
    Q=C
    QS=Q\f
//  end
//  err=norm(V-W,'inf')
  err=norm(f-F,'inf')
   ct=f'*QS+cs
  printf("|  %2d  | %2.3e | %2.1e |",iter,ct,err)
//  V=W
  F=f
end
//f=min(0,QS)*pen+C*max(0,QS)

function [W,f,iter]=WardropC(H,d,a,pre)
pen=0.01
ci=10
C=0.1
err=100
[m,n]=size(H)
V=ones(m,1)
un=ones(n,1)
nd=size(d,2)
D=d*ones(nd,1)
Q=diag(sparse(un*C))
qs=zeros(n,1)
QS=qs 
q=sparse(ones(n,nd)*ci)
iter=1
while err>pre 
  iter=iter+1
  DD=nd*D+H*Q*qs
  W=lusolve(H*Q*H'+a*speye(m,m),DD);
  QS=(H'*W-qs)/nd
  Q=diag(sparse(max(0.001,C*real(un./sqrt(QS)))))
  qs=spzeros(n,1)
  for i=1:nd
    di=d(:,i)+H*diag(QS)*q(:,i)
    w=lusolve(H*sparse(diag(q(:,i)))*H'+a*speye(m,m),di);
    qqq=H'*w-QS
    qs=qs+qqq
     q(:,i)=sparse(max(pen,ci*real(un./sqrt(qqq))))
  end 
  err=norm(V-W,'inf')
  disp(iter,err)
  V=W
end
f=Q

function [v,Q,iter]=fluideHow(H,d,a,pre)
err=1
[m,n]=size(H)
v=ones(m,1)
un=ones(n,1)
q=diag(sparse(un/2.0))
iter=1
while err>pre 
  iter=iter+1
  disp(iter)
  w=lusolve(H*q*H'+a*speye(m,m),d);
  q=diag(sparse(un./sqrt(abs(H'*w))))
  err=norm(v-w,'inf')
  disp(err)
  v=w
end
Q=q*H'*w


function [v,Q,iter]=fluide(H,d,r,a,pre)
err=1
[m,n]=size(H)
v=ones(m,1)
un=ones(n,1)
R=diag(sparse(r))
q1=r
q=R
iter=0
printf("  ")
printf("=====================")
printf("Fluide/C/%5d/%5d/",m,n)
printf("=====================")
printf("  ")
printf("------------------")
printf("| iter |  erreur |")
printf("------------------")
while err>pre 
  iter=iter+1
  d1=2*d-H*q1
  w=lusolve(H*q*H'+a*speye(m,m),d1);
  q1=(q*H'*w+q1)/2
  q=R*diag(sparse(un./abs(q1)))
  err=norm(v-w,'inf')
  printf("|  %2d  | %2.1e |",iter,err)
  v=w
end
Q=q1

function [v,Q,iter]=wardropq1(H,d,r,a,pre,niter)
err=1
[m,n]=size(H)
v=ones(m,1)
un=ones(n,1)
R=diag(sparse(r))
q1=r
q=R
iter=0
printf("  ")
printf("=====================")
printf("Wardrop1/Q/%4d/%4d/",m,n)
printf("=====================")
printf("  ")
printf("------------------")
printf("| iter |  erreur |")
printf("------------------")
while err>pre & iter<niter
  iter=iter+1
//  pause
  w=lusolve(H*q*H'+a*speye(m,m),d);
  q1=H'*w
  q=R*diag(sparse(max(0,sign(q1))))
  err=norm(v-w,'inf')
  printf("|  %2d  | %2.1e |",iter,err)
  v=w
end
Q=R*max(0,q1)

function [F,q,w]=WardropQ(H,d,r,a,pre,niter)
R=diag(sparse(r));
err=1;
[m,n]=size(H);
un=ones(n,1);
unm=ones(m,1);
nd=size(d,2);
und=ones(nd,1);
w=ones(m,nd);
D=full(d*und);
Q=R;
F=r;
sq=diag(sparse(un));
q=r*ones(1,nd);
//
// Resolution du probleme agrege
//
iter=0;
printf("  ")
printf("==========================")
printf("Wardropn/Q/%4d/%4d/%4d/",m,n,nd)
printf("==========================")
printf("  ")
printf("------------------")
printf("| iter |  erreur |")
printf("------------------")
iter=0
while niter>iter & err>pre
  iter=iter+1;
  ww=lusolve(H*sq*H'+a*speye(m,m),D);
  qq=H'*ww;
  sq=diag(sparse(R*max(0,sign(qq))));
  f=sq*qq;
  err=norm(f-F,'inf')
  printf("|  %2d  | %2.1e |",iter,err)
  F=f
end
printf("==================");
errV=norm(diag(sparse(sign(F)))*(R*H'*ww-F));
errQ=norm(H*F-D);
printf("|errV=%2.1e|errQ=%2.1e|",errV,errQ);
printf("==================");
//
// Iteration pour assurer la positivite
// des flots individuels.
//
iter=0;
err=1;
for i=1:nd
  q(:,i)=f/nd;
end
while niter>iter & err>pre
  iter=iter+1;
  for i=1:nd
    qi=q(:,i);
    fi=f-qi;
    admit=diag(sparse(sign(qi)));
    iteri=0;
    erri=1;
    w(:,i)=unm;
    while 8>iteri & erri>pre
      iteri=iteri+1;
      di=d(:,i)+H*admit*fi;
      ww=lusolve(H*admit*R*H'+a*speye(m,m),di);
      qi=max(R*H'*ww-fi,0);
      admit=diag(sparse(sign(qi)));
      erri=norm(ww-w(:,i));
      w(:,i)=ww;
    end
    q(:,i)=qi;
    f=fi+qi;
  end 
  f=q*und
  err=norm(f-F,'inf')
  printf("|  %2d  | %2.1e |",iter,err)
  F=f
end
printf("==================")
errV=0;
errQ=0;
for i=1:nd
  errV=errV+norm(diag(sparse(sign(q(:,i))))*(R*H'*w(:,i)-F));
  errQ=errQ+norm(H*q(:,i)-d(:,i));
end
printf("|errV=%2.1e|errQ=%2.1e|",errV/nd,errQ/nd);
printf("==================");

function [F,q,w]=WardropLQ(H,d,l,r,a,k,pre,niter)
R=diag(sparse(r));
err=1;
[m,n]=size(H);
un=ones(n,1);
unm=ones(m,1);
nd=size(d,2);
und=ones(nd,1);
w=ones(m,nd);
D=full(d*und);
Q=R;
F=r;
sq=diag(sparse(un));
q=r*ones(1,nd);
//
// Resolution du probleme agrege
//
iter=0;
printf("  ")
printf("==========================")
printf("Wardropn/Q/%4d/%4d/%4d/",m,n,nd)
printf("==========================")
printf("  ")
printf("------------------")
printf("| iter |  erreur |")
printf("------------------")
iter=0;
ac=a
while niter>iter & err>pre
  ac=ac/k;
  iter=iter+1;
  DL=D*sqrt(nd)+H*sq*R*l
  ww=lusolve(H*sq*R*H'+ac*speye(m,m),DL);
  f=max(0,R*(H'*ww-l));
  sq=diag(sparse(sign(f)));
  err=norm(f-F,'inf')
  printf("|  %2d  | %2.1e |",iter,err)
  F=f
end
printf("==================");
errV=norm(diag(sparse(sign(F)))*(R*(H'*ww-l)-F))/norm(F);
errQ=norm(H*F-sqrt(nd)*D)/(sqrt(nd)*norm(D));
printf("|errV=%2.1e|errQ=%2.1e|",errV,errQ);
printf("==================");
//
// Iteration pour assurer la positivite
// des flots individuels.
//
iter=0;
err=1;
ac=a;
for i=1:nd
  q(:,i)=f/nd;
end
while niter>iter & err>pre
  ac=ac/k;
  iter=iter+1;
  for i=1:nd
    qi=q(:,i);
    fi=f-qi;
    admit=diag(sparse(sign(qi)));
    iteri=0;
    erri=1;
    w(:,i)=unm;
    while 8>iteri & erri>pre
      iteri=iteri+1;
      di=d(:,i)+H*admit*(fi+R*l);
      ww=lusolve(H*admit*R*H'+ac*speye(m,m),di);
      qi=max(R*(H'*ww-l)-fi,0);
      admit=diag(sparse(sign(qi)));
      erri=norm(ww-w(:,i));
      w(:,i)=ww;
    end
    q(:,i)=qi;
    f=fi+qi;
  end 
  f=q*und
  err=norm(f-F,'inf')
  printf("|  %2d  | %2.1e |",iter,err)
  F=f
end
printf("==================")
errV=0;
errQ=0;
for i=1:nd
  errV=errV+norm(diag(sparse(sign(q(:,i))))*(R*(H'*w(:,i)-l)-F));
  errQ=max(errQ,norm(H*q(:,i)-d(:,i),"inf"));
end
printf("|errV=%2.1e|errQ=%2.1e|",errV/(nd*norm(F)),errQ/norm(q,"inf"));
printf("==================");
