//////////////////////////////////////////////////////////////
////////      Graph-list manipulation       //////////////////
//////////////////////////////////////////////////////////////
function [g,lpp,d,f,tt]=desassembler(tn)
hcolor=tn("edge_color")
nn=tn("node_number")
nd=prod(size(find(hcolor==12)))
na=edge_number(tn)-nd
H=graph_2_mat(tn)
g=mat_2_graph(H(:,1:na),1)
g('node_x')=tn('node_x')
g('node_y')=tn('node_y')
t0=tn("edge_min_cap")
ca=tn("edge_max_cap")
ma=tn("edge_q_weight")
ba=tn("edge_q_orig")
f=tn("edge_weight")
tt=tn("edge_cost")
lpp=[t0(1:na)',ca(1:na)',ma(1:na)',ba(1:na)']
ds=f(na+1:$)
f=f(1:na)'
tt=tt(1:na)'
d=zeros(nn,nd)
ta=tn("tail")
he=tn("head")
for i=1:nd,
	d(ta(i+na),i)=ds(i)
	d(he(i+na),i)=-ds(i)
end


function tn=assembler(g,lpp,d,f,nf)
[narg1,narg]=argn(0)

tn=g
na=edge_number(g)

if narg>=3,
	nd=size(d,2)
	for j=1:nd
		i1=find(d(:,j)>0)
		i2=find(d(:,j)<0)
		tn=add_edge(i1,i2,tn)
	end
else nd=0;
end

if narg<4 then f=0, end

f=max(sum(f,'c'),0)   //Truncates negative flows
mf=max(f)
hcolor=ones(1,na)

if mf>0, tn("edge_width")=[5*f'/mf,3*ones(1,nd)]
	hcolor(find(f==0))=4
end	

tn("edge_color")=[hcolor,12*ones(1,nd)]

if narg<5, nf=6,end;

if nd>0,
	df=max(full(d),"r");
	tn("edge_weight")=[zeros(1,na),df],
else df=[],
end

if narg>=2,
// t0 ca ma beta
tn("edge_min_cap")= [lpp(:,1)',df]
tn("edge_max_cap")= [lpp(:,2)',df]
tn("edge_q_weight")= [lpp(:,3)',df]
tn("edge_q_orig")= [lpp(:,4)',df]
end

if narg>=4,
	costo=lpf(f,lpp,nf)
	tn("edge_cost")= [decimal(costo',2),df]
	tn("edge_weight")=[decimal(f',2),df]
end













//////////////////////////////////////////////////////////////
//////     Random generation of parameters      //////////////
//////////////////////////////////////////////////////////////
function electos=elegir(j,n)
q=1:n
electos=[]
for i=1:j
q=q(find(q>0))
cual=1+int(rand(1,"uniform")*size(q,2))
electos=[electos,q(cual)]
q(cual)=0;
end

function res=decimal(x,n)
res=int(x*10^n)/10^n

function [g,d,lpp]=traffic(nn,na,nd)
// generates random node-arc incidence matrix
H=spzeros(nn,na);
for j=1:na,
    ij=[0,0];
    while ij(1)==ij(2), ij=ceil(nn*rand(2,1)); end;
    H(ij(1),j)=1;
    H(ij(2),j)=-1;
end

// generates random inputs-outputs
d=spzeros(nn,nd);
for j=1:nd
	ij=[0,0];
        while ij(1)==ij(2), ij=ceil(nn*rand(2,1)); end;
        dem=1+int(9*rand())
        d(ij(1),j)=dem;
        d(ij(2),j)=-dem;
end
r=max(0.1,rand(na,1));
lpp=[0*r,0*r,r,0*r+2];

g=mat_2_graph(H,1);


function [g,d,lpp]=trafficn(nn,pna,dispe,nd)
// generates random node-node incidence matrix
H=spzeros(nn,nn);
for j=1:nn,
    H(j,elegir(pna+dispe*rand(1,"normal"),nn))=1
    H(j,j)=0
end
g=mat_2_graph(H,1,"node-node");
na=edge_number(g);

// generates random inputs-outputs
d=spzeros(nn,nd);
for j=1:nd
	ij=[0,0];
        while ij(1)==ij(2), ij=ceil(nn*rand(2,1)); end;
        dem=1+int(9*rand())
        d(ij(1),j)=dem;
        d(ij(2),j)=-dem;
end
r=max(0.1,rand(na,1));
lpp=[0*r,0*r,r,0*r+2];




//////////////////////////////////////////////////////////////
//////     Link Perfomance function    ///////////////////////
//////////////////////////////////////////////////////////////

function c=lpf(F,lpp,nf)
// F=total flow on each arc
// na=number of arcs
// lpp=link perfomance parameters (na x 4 matrix)
// nf= travel time formula used
fF=full(F)
t0=lpp(:,1)
ca=lpp(:,2)
ma=lpp(:,3)
ba=lpp(:,4)

if     nf==0, c=t0+ma./ca.*fF+ma.*(max(0,fF-ca)).^ba
elseif nf==1, c=t0.*exp(fF./ca-1)
elseif nf==2, c=t0.*2.^(fF./ca-1)
elseif nf==3, c=t0.*(1+0.15*(fF./ca).^ma)
elseif nf==4, c=t0+log(ca)-log(ca-fF)
elseif nf==5, c=ba-ca.*(t0-ba)./(fF-ca)
elseif nf==6, c=t0+ma.*fF.^ba
else disp("error in lpf")
end

function aa=dlpf(ini,inc,fin,lpp,nf)
// Grafica la lpf  para f variando entre ini y fin
// nf= numero de formula para lpf
aa=[];
na=size(lpp,1)
for j=ini:inc:fin,
aa=[aa,lpf(ones(na,1)*j,lpp,nf)];
end
plot2d((ini:inc:fin)'*ones(1,na),aa')


//////////////////////////////////////////////////////////////
////////// Show the used paths ///////////////////////////////
//////////////////////////////////////////////////////////////


function show_path(g,d,f,lpp,nf)
// g graph
// d demand
// f flow
// In black the used arc with thickness proportional to the flow
// In red the demands
// In ligth blue the unused arcs (flow=0)
[narg1,narg]=argn(0)
h=g
nd=size(d,2)
f=sum(f,'c')
for j=1:nd
	i1=find(d(:,j)>0)
	i2=find(d(:,j)<0)
	h=add_edge(i1,i2,h)
end
mf=max(max(f),0.01)
h("edge_width")=[5*f'/mf,3*ones(1,nd)]
hcolor=ones(f)'
hcolor(find(f==0))=4
h("edge_color")=[hcolor,12*ones(1,nd)]
if narg>=4,
if narg==4,nf=6;end;
costo=lpf(f,lpp,nf)
h("edge_cost")= [decimal(costo',2),max(full(d),"r")];
h("edge_q_weight")= [lpp(:,3)',max(full(d),"r")];
end
h("edge_weight")=[decimal(f',2),max(full(d),"r")]
show_graph(h)	



//////////////////////////////////////////////////////////////
//////     All or Nothing      ///////////////////////////////
//////////////////////////////////////////////////////////////

function f=AON(g,d,ca)
// g= graph of the traffic network
// d= demand matrix dpq=flow from node p to node q (n x nd matrix)
// n=number of nodes
// na=number of arcs
// nd=number of demands (clientes)=number of non zero coef of d

// for each non zero dpq find the shortest path from p to q
[narg1,narg]=argn(0)
if narg==3, g("edge_length")=ca'; end
[n,nd]=size(d)
na=size(g("tail"),2)
f=zeros(na,nd)
for i=1:nd,
p=find(d(:,i)>0);q=find(d(:,i)<0);
[SP,C]=shortest_path(p,q,g,"length")
f(SP,i)=d(p,i)
end



//////////////////////////////////////////////////////////////
//////     Iterated All or Nothing     ///////////////////////
//////////////////////////////////////////////////////////////

function f=IAON(g,d,lpp,kmax,nf)
[narg1,narg]=argn(0)
if narg<5, nf=6, end
if narg<4, kmax=20,end
minerr=0.001
// Step 0
t0=lpp(:,1);tn=t0
g("edge_length")=t0'
f=AON(g,d)
F=sum(f,"c")
k=0
terminate=%F

while ~terminate
// Step 1
	V=F
	tv=tn;tn=lpf(V,lpp,nf)
	g("edge_length")=tn'
	y=AON(g,d)
	Y=sum(y,"c")

// Step 2
	f=y
	F=Y
	k=k+1

// Step 3
	if (k>kmax)|(norm(tn-tv)<minerr) then terminate=%T; end

end





//////////////////////////////////////////////////////////////
//////  CAPRES algorithm     /////////////////////////////////
//////////////////////////////////////////////////////////////


function f=capres(g,d,lpp,nf)
[narg1,narg]=argn(0)
if narg<4, nf=6, end


kmax=4

// Step 0
t0=lpp(:,1)
g("edge_length")=t0'
y=AON(g,d)
Y=sum(y,"c")
f=AON(g,d)
F=sum(y,"c")
k=0
terminate=%F

while ~terminate
// Step 1
	V=(1-1/kmax)*F+(1/kmax)*Y
        g("edge_length")=lpf(V,lpp,nf)'
	y=AON(g,d)
	Y=sum(y,"c")

// Step 2
	f=(1-1/kmax)*f+(1/kmax)*y
	F=sum(f,"c")
	k=k+1

// Step 3
	if (k>=kmax) then terminate=%T; end

end



//////////////////////////////////////////////////////////////
//////  Incremental Assignment algorithm   ///////////////////
//////////////////////////////////////////////////////////////


function f=IA(g,d,lpp,K,nf)
[narg1,narg]=argn(0)
if narg<5, nf=6,end
if narg<4, K=20,end
kmax=K
alfa=1/K

// Step 0
t0=lpp(:,1)
y=AON(g,d,t0)
Y=sum(y,"c")
f=alfa*y
F=sum(f,"c")
k=1
terminate=%F

while ~terminate
// Step 1
	V=F;
	y=AON(g,d,lpf(V,lpp,nf))
	Y=sum(y,"c")

// Step 2
	f=f+alfa*y
	F=F+alfa*Y
	k=k+1

// Step 3
	if (k>=kmax) then terminate=%T; end

end



//////////////////////////////////////////////////////////////
//////  Frank-Wolfe algorithm         ////////////////////////
//////////////////////////////////////////////////////////////


function f=EA(g,d,lpp,kmax,tol,nf)

// Remark: It is assumed that the travel time model is the quadratic one
//  if not the formula for Js (the second derivate of the global cost)
//  must be changed


[narg1,narg]=argn(0)
if narg<6, nf=6,end
if narg<5, tol=1e-6,end
if narg<4, kmax=20,end


// Step 0
t0=lpp(:,1)
f=AON(g,d,t0)
F=sum(f,"c")
itemax=20
k=1
terminate=%F


while ~terminate
// Step 1
	y=AON(g,d,lpf(F,lpp,nf))
	Y=sum(y,"c")

// Step 2
	// Search for lambda that minimizes the global cost
	l=0.5
	ln=0
	iter=1
	ca=0
//	disp('k =  ');disp(k)
	while abs(ln-l)>tol & iter<=itemax
		l=ln
		cv=ca
		ca=lpf((1-l)*F+l*Y,lpp,nf)
		Jp=ca'*(Y-F)
		if abs(Jp)>tol
			r=lpp(:,3)
			if lpp(1,4)==1, Js=(Y-F)'*diag(r)*(Y-F), end
			if lpp(1,4)==2,Js=2*r'*((1-l)*F+l*Y)*(Y-F)'*(Y-F), end
			ln=l-Jp/Js
		end
		if ln<=0, ln=0, end
		if ln>=1, ln=1, end
		iter=iter+1
//		disp([l Jp Js -Jp/Js ln])
	end
// Step 3
	f=(1-ln)*f+ln*y
	F=sum(f,'c')
	k=k+1	

// Step 3
	if (k>=kmax)| (norm(ca-cv)<tol) then terminate=%T; end
//	disp('norm')
//	disp(norm(cv-ca))

end
sol=f


//////////////////////////////////////////////////////////////
//////  Traffic Assigment algorithm    ///////////////////////
//////////////////////////////////////////////////////////////


function tna=Traffic_Assig(tn,niter,algo,nf)
[narg1,narg]=argn(0)
if narg<4, nf=6, end
if narg<3 then algo="IA",end
if narg<2 then niter=50, end
[g,lpp,d]=desassembler(tn)
err=0
if algo=="FW" then
	f=EA(g,d,lpp,niter,1e-6,nf);
elseif  algo=="IA" then
	f=IA(g,d,lpp,niter,nf);
else
	disp("Wrong name of the algorithm");
	err=1;
end
if err==0,  tna=assembler(g,lpp,d,f), end







/////////////////////////////////////////
// Comparation of algorithms  ///////////
/////////////////////////////////////////

function versus(g,d,lpp)
fIA=IA(g,d,lpp,100)
fTA=EA(g,d,lpp,100)


ws=netwindows();ws=ws(1);
if length(ws)>=2 then
	w1=netwindow(ws($-1))
	g('name')='Incremental assignment'
	show_path(g,d,sum(fIA,"c"),lpp)
	w2=netwindow(ws($))
	g('name')='Equilibrium assignment'
	show_path(g,d,sum(fTA,"c"),lpp)
else
	w1=metanet()
	g('name')='Incremental assignment'
	show_path(g,d,sum(fIA,"c"),lpp)
	w2=metanet()
	g('name')='Equilibrium assignment'
	show_path(g,d,sum(fTA,"c"),lpp)
end
