.TH star  " " " " "Maxplus Function"
.SH NAME
star - maxplus star
.SH CALLING SEQUENCE
.nf
B=star(A)
.fi
.SH PARAMETERS
.TP 10
A
: maxplus full square matrix
.TP 10
B
: Id+A+A^2+.....
.SH DESCRIPTION
Solve \fVx=Ax+Id\fR in the maxplus algebra.
When there is no circuits with positive weight in
G(A) (the incidence graph of A) \fVB=Id+A+.....A^(n-1)\fR
where n denotes the order of the square matrix A.
.SH EXAMPLES
.nf
star(#(1))
star(#(-1))
star(#([1,2;3,4]))
a=#([-3,-2;-1,0]); b=star(a)
b==%eye(2,2)+a
b==b+a*a
.fi
.SH SEE ALSO
plus,
karp,
howard,
semihoward,
maxplus




